<?php
/***************************************************************************\
 *  Plugin Statistiques pour les brves                          	      	 *
 *  Copyright (c) 2007-2009                                                *
 *  Elrik - Peetdu - Mathieu Carrandi                                     *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;
 
include_spip('inc/presentation');

// debut de la fonction principale
function exec_stats_breves_tableau() {

  $commencer_page = charger_fonction('commencer_page', 'inc');
  echo $commencer_page(_T('stbrv:statistiques_breves'), _T('stbrv:statistiques_breves'), _T('stbrv:statistiques'))."\n";
  echo "<br /><br /><br />\n";
  echo gros_titre(_T("stbrv:statistiques_breves"),'',false);

  // colonne gauche
	echo debut_gauche('', true);

	echo "<div class='iconeoff' style='padding: 5px;'>";
	echo "<div style='font-size:small;' class='verdana1'>";
	echo typo(_T('info_afficher_visites'));
	echo "<ul>";
	echo "<li><b><a href='" . generer_url_ecrire("statistiques_visites","") . "'>"._T('info_tout_site')."</a></b></li>";
	echo "</ul>";
	echo "</div>";
	echo "</div>";
	
	echo "<br /><div class='iconeoff' style='padding: 5px;'>";
	echo "<div style='font-size:small;overflow:hidden;' class='verdana1'>";
	echo typo(_T('stbrv:breves_les_plus_visites'));
	echo html_stats_breves_detail();
	echo "</div>";
	echo "</div>";
	
  // centre
  echo debut_droite('', true);
	//le tableau  barres horizontales
  echo debut_cadre_relief("statistiques-24.gif",true,'','');
		echo html_stats_breves_tab();
	
  echo fin_cadre_relief(true);
	
  echo debut_boite_info(true);
  echo typo(_T('stbrv:boite_info_breves_tableau'));
	echo fin_boite_info(true);

  echo fin_gauche(), fin_page();
 } // fin fonction

function get_stats_breves($tri, $sort="DESC") {
  $champs = array('id_breve', 'visites', 'titre', 'date_heure');
  $from = "spip_breves";
  $where = array("statut = 'publie'");
  if ($tri=="visites") {
	  $orderBy = array("visites ".$sort);
  } elseif ($tri=="titre") {
	  $orderBy = array("titre ".$sort);
  } else {
	  $orderBy = array("date_heure ".$sort);
  }
  $limit=50;
	
  $stats= sql_allfetsel($champs, $from, $where, '', $orderBy, $limit);
	return $stats;
}

function get_stats_breves_les_plus_populaires() {
  $champs = array('id_breve', 'visites', 'titre', 'date_heure');
  $from = "spip_breves";
  $where = array("statut = 'publie'");
  $orderBy = array("visites DESC");
  $limit=20;

  $stats = sql_allfetsel($champs, $from, $where, '', $orderBy, $limit);  
  return $stats;
}


function html_stats_breves_tab() {

	global $couleur_claire;
	$couleur_titre = $couleur_date = $couleur_visites = "";
		
	$tri = _request('tri');
	$tri = ($tri == "") ? "date" : $tri;
	$sort = _request('sort');
	$sort = ($sort == "") ? "DESC" : $sort;
	$stats = get_stats_breves($tri, $sort);
	# On inverse l'ordre de tri pour la colonne actuellement slectionne
	switch ($tri) {
		case "titre":
			$couleur_titre = "bgcolor='".$couleur_claire."' ";
			if ($sort == "DESC") {
				$b_sort = "ASC";
			} else {
				$b_sort = "DESC";
			}
			$d_sort = $sort;
			$v_sort = $sort;
			break;
		case "date":
			$couleur_date = "bgcolor='".$couleur_claire."' ";
			if ($sort == "DESC") {
				$d_sort = "ASC";
			} else {
				$d_sort = "DESC";
			}
			$b_sort = $sort;
			$v_sort = $sort;
			break;
		case "visites":
			$couleur_visites = "bgcolor='".$couleur_claire."' ";
			if ($sort == "DESC") {
				$v_sort = "ASC";
			} else {
				$v_sort = "DESC";
			}
			$b_sort = $sort;
			$d_sort = $sort;
			break;
	}
	if (count($stats) == 0) {
		return "<p>"._T('stbrv:aucune_breve_trouvee')."</p>";
	}
	$html = '<table width="100%" style="font-size:10px;"><tr>';
	$html .= '<th width="75%" '.$couleur_titre.'><a href="?exec=stats_breves_tableau&tri=titre&sort='.$b_sort.'" title="Trier par id_breve">'._T('stbrv:breve').'</th>';
	$html .= '<th width="17%" '.$couleur_date.'style="text-align:center;"><a href="?exec=stats_breves_tableau&tri=date&sort='.$d_sort.'" title="Trier par date de mise en ligne">'._T('stbrv:date_creation').'</a></th>';
	$html .= '<th width="8%" '.$couleur_visites.'style="text-align:right;"><a href="?exec=stats_breves_tableau&tri=visites&sort='.$v_sort.'" title="Trier par visites">'._T('stbrv:nombre_visites').'</a></th>';
	$html .= '</tr>'."\n";
	for ($i=0; $i<count($stats); $i++) {
		$breve = $stats[$i];
		$html.='<tr class="tr_liste">
            <td><a href="'.generer_url_ecrire("stats_breves_detail","id_breve=".$breve['id_breve']).'">'.$breve['titre'].'</a></td>'."\n";
		$html.='<td style="text-align:center;">'.($breve['date_heure']?strftime('%d %b %Y',strtotime($breve['date_heure'])):'?').'</td>'."\n";
		$html.='<td style="text-align:right;">'.$breve['visites'].'</td>'."\n</tr>\n";
	}
	$html.='</table>'."\n";
	return $html;
}

function html_stats_breves_detail() {
	$stats = get_stats_breves_les_plus_populaires();
	if (count($stats) == 0) {
		return "<p>"._T('stbrv:aucune_breve_trouvee')."</p>";
	}
	$html = "<ol style='padding-left:30px; font-size:x-small;color:#666666;'>\n";
	for ($i=0; $i<count($stats); $i++) {
		$breve = $stats[$i];
		$html .= '<li><a href="?exec=stats_breves_detail&id_breve='.$breve['id_breve'].'" title="visites : '.$breve['visites'].'">'.$breve['titre'].'</li>'."\n";
	}
	$html .= "</ol>";
	return $html;
} 
 
?>
